/*   ants.h --- Your description here
 *
 *   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA **/
#ifndef ANTS_H
#define ANTS_H    /*+ To stop multiple inclusions. +*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <dtk/dtk.h>


#define MW 304
#define MH 304

/* initial nb ant in _ant.c */
/* initial nb food in world.c */

#define NESTX (MW/2)
#define NESTY (MH/2)
#define NEST_RADIUS 10

#define MAX_ANTS 4096
#define MAX_FOOD 100

#define DEFAULT_REST 4095					 /* quantity of food in repository */
#define ANT_STRENGTH 5						 /* quantity of food an ant can carry */

#define from_nest 1

#define _active_trail_start 190;
#define _active_trail_end 160;


#ifndef THREAD_C
#include <stdio.h>
extern FILE *randwm,*attrm,*tracem,*gohm,*foodm;
extern int nb_rand,nb_attr,nb_trace,nb_go,nb_food;
#ifdef HAVE_LIBJPEG
extern int save_jpeg;
extern char *save_jpeg_dir;
#endif
#endif

typedef enum {searching, trace, going_home} Ants_state;
typedef struct
{
  int posx;
  int posy;
  int direction;
  int food;
  Ants_state state;
}ANT;

typedef struct
{
  int x;
  int y;
  int rest;
} FOOD;

typedef struct
{
  unsigned char msb;
  unsigned char lsb;
}PIXEL;


#ifndef ANTS_C
extern XImage * im;
extern Form *sw;
extern Form *pix;
extern void redraw_pixmap (Form *i);

extern char use_pheronom;
extern char use_noise;
#endif

#ifndef THREAD_C
extern void init_thread(void);
extern void stop_thread(void);
extern int frame;
#endif


#ifndef WORLD_C
extern unsigned char * pheromon1;
extern float wind_angle;
extern float wind_strength;
extern int nbfood;
extern char food_repartion;
extern char draw_pheromon;
extern FOOD food[];
extern int nest_pheromon[MH][MW];
extern void init_world(void);
extern void world2image(void);
extern void diffusion_evaporation_pheromon(void);
extern void wind (float dir, float strenght);
extern void draw(int x,int y);
extern void undraw(int x,int y);
#define acces1(x,y) (*(pheromon1+(y)*MW+(x)))
#endif

#ifndef DRAWING_C
extern void drawing_motion(Form *i);
extern void draw_food(PIXEL *im,FOOD f);
extern void draws(int x,int y,int s);
#endif

#ifndef OPTIONS_C
extern void init_options_window(void);
extern void view_options_window(void);
#endif

#ifndef _ANTS_C
extern int nbants;
extern ANT ant[MAX_ANTS];
extern void ant_behavior(int i);
extern void init_ants(int i);
#endif

#ifdef HAVE_LIBJPEG
#define  HAVE_BOOLEAN
#include "jpeglib.h"
extern JSAMPLE * image_buffer;	/* Points to large array of R,G,B-order data */
extern int image_height;	/* Number of rows in image */
extern int image_width;
#endif

#endif /* ANTS_H */
